Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nikon.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nikon.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nikon.pm	(revision 34921)
@@ -2310,19 +3627,110 @@
             },
         },
-        { #29
+        { #29/PH
             Name => 'AFPointsUsed',
             Condition => '$$self{PhaseDetectAF} == 3',
-            Notes => 'models with 39-point AF: D7000 (not decoded)',
+            Notes => q{
+                models with 39-point AF -- 5 rows: A1-3, B1-11, C1-11, D1-11, E1-3.  Center
+                point is C6
+            },
+            Format => 'undef[5]',
+            ValueConv => 'join(" ", unpack("H2"x5, $val))',
+            ValueConvInv => '$val=~tr/ //d; pack("H*",$val)',
+            PrintConv => sub { PrintAFPoints(shift, \%afPoints39); },
+            PrintConvInv => sub { PrintAFPointsInv(shift, \%afPoints39); },
+        },
+        { #PH (1AW1,1J1,1J2,1J3,1S1,1V1,1V2)
+            Name => 'AFPointsUsed',
+            Condition => '$$self{PhaseDetectAF} == 4',
+            Notes => q{
+                older models with 135-point AF -- 9 rows (A-I) and 15 columns (1-15).
+                Center point is E8.  The odd-numbered columns, columns 2 and 14, and the
+                remaining corner points are not used for 41-point AF mode
+            },
+            Format => 'undef[17]',
+            ValueConv => 'join(" ", unpack("H2"x17, $val))',
+            ValueConvInv => '$val=~tr/ //d; pack("H*",$val)',
+            PrintConv => sub { PrintAFPoints(shift, \%afPoints135); },
+            PrintConvInv => sub { PrintAFPointsInv(shift, \%afPoints135); },
+        },
+        { #PH (1S2)
+            Name => 'AFPointsUsed',
+            Condition => '$$self{PhaseDetectAF} == 5',
+            Notes => q{
+                newer models with 135-point AF -- 9 rows (B-J) and 15 columns (1-15). Center
+                point is F8
+            },
+            Format => 'undef[21]',
+            ValueConv => 'join(" ", unpack("H2"x21, $val))',
+            ValueConvInv => '$val=~tr/ //d; pack("H*",$val)',
+            PrintConv => sub { PrintAFPointsGrid(shift, 15); },
+            PrintConvInv => sub { PrintAFPointsGridInv(shift, 15, 21); },
+        },
+        { #PH (1J4,1V3)
+            Name => 'AFPointsUsed',
+            Condition => '$$self{PhaseDetectAF} == 6',
+            Notes => q{
+                models with 171-point AF -- 9 rows (B-J) and 19 columns (2-20).  Center
+                point is F10
+            },
+            Format => 'undef[29]',
+            ValueConv => 'join(" ", unpack("H2"x29, $val))',
+            ValueConvInv => '$val=~tr/ //d; pack("H*",$val)',
+            PrintConv => sub { PrintAFPointsGrid(shift, 21); },
+            PrintConvInv => sub { PrintAFPointsGridInv(shift, 21, 29); },
+        },
+        { #PH (D5,D500)
+            Name => 'AFPointsUsed',
+            Condition => '$$self{PhaseDetectAF} == 7',
+            Notes => q{
+                models with 153-point AF -- 9 rows (A-I) and 17 columns (1-17). Center
+                point is E9
+            },
+            Format => 'undef[20]',
+            ValueConv => 'join(" ", unpack("H2"x20, $val))',
+            ValueConvInv => '$val=~tr/ //d; pack("H*",$val)',
+            PrintConv => sub { PrintAFPoints(shift, \%afPoints153); },
+            PrintConvInv => sub { PrintAFPointsInv(shift, \%afPoints153); },
+        },
+        { #38 (Z6/Z7/Z50)
+            Name => 'AFPointsUsed',
+            Condition => '$$self{PhaseDetectAF} == 8 and $$self{Model} =~ /^NIKON Z/',
+            Notes => q{
+                models with 81-selectable point AF -- 9 rows (A-I) and 9 columns (1-9) for
+                phase detect AF points. Center point is E5
+            },
+            Format => 'undef[13]',
+            ValueConv => 'join(" ", unpack("H2"x13, $val))',
+            ValueConvInv => '$val=~tr/ //d; pack("H*",$val)',
+            PrintConv => sub { PrintAFPoints(shift, \%afPoints81); },
+            PrintConvInv => sub { PrintAFPointsInv(shift, \%afPoints81); },
+        },
+        { #PH
+            Name => 'AFPointsUsed',
+            # version 301 uses a separate field at offset 0x0a for this tag (ref 28)
+            Condition =>  '$$self{AFInfo2Version} ne "0301"',
             Format => 'undef[7]',
-            PrintConv => '$_=unpack("H*",$val); "Unknown (".join(" ", /(..)/g).")"',
-        },
-        {
+            ValueConv => 'join(" ", unpack("H2"x7, $val))',
+            ValueConvInv => '$val=~tr/ //d; pack("H*",$val)',
+            PrintConv => '"Unknown ($val)"',
+            PrintConvInv => '$val=~s/Unknown \\((.*)\\)/$1/; $val',
+        },
+    ],
+    0x0a => { #28 (D6) in any of the 3 Group modes on the D6, the points specify the outer boundaries of the focus point area; otherwise the tag value is consistent with other Nikon bodies
             Name => 'AFPointsUsed',
-            Format => 'undef[7]',
-            PrintConv => '$_=unpack("H*",$val); "Unknown (".join(" ", /(..)/g).")"',
-        },
-    ],
+        Condition => '$$self{AFInfo2Version} eq "0301"  and $$self{PhaseDetectAF} == 9',
+        Notes => q{
+            models with 105-point AF -- 7 rows (A-G) and 15 columns (1-15). Center
+            point is D8
+        },
+        Format => 'undef[14]',
+        ValueConv => 'join(" ", unpack("H2"x14, $val))',
+        ValueConvInv => '$val=~tr/ //d; pack("H*",$val)',
+        PrintConv => sub { PrintAFPoints(shift, \%afPoints105); },
+        PrintConvInv => sub { PrintAFPointsInv(shift, \%afPoints105); },
+    },
     0x10 => { #PH (D90 and D5000)
         Name => 'AFImageWidth',
+        Condition => '$$self{AFInfo2Version} eq "0100"',
         Format => 'int16u',
         RawConv => '$val ? $val : undef',
@@ -2331,4 +3739,5 @@
     0x12 => { #PH
         Name => 'AFImageHeight',
+        Condition => '$$self{AFInfo2Version} eq "0100"',
         Format => 'int16u',
         RawConv => '$val ? $val : undef',
@@ -2336,4 +3745,5 @@
     0x14 => { #PH
         Name => 'AFAreaXPosition',
+        Condition => '$$self{AFInfo2Version} eq "0100"',
         Notes => 'center of AF area in AFImage coordinates',
         Format => 'int16u',
@@ -2342,4 +3752,5 @@
     0x16 => { #PH
         Name => 'AFAreaYPosition',
+        Condition => '$$self{AFInfo2Version} eq "0100"',
         Format => 'int16u',
         RawConv => '$val ? $val : undef',
@@ -2350,4 +3761,5 @@
     0x18 => { #PH
         Name => 'AFAreaWidth',
+        Condition => '$$self{AFInfo2Version} eq "0100"',
         Format => 'int16u',
         Notes => 'size of AF area in AFImage coordinates',
@@ -2356,12 +3768,190 @@
     0x1a => { #PH
         Name => 'AFAreaHeight',
+        Condition => '$$self{AFInfo2Version} eq "0100"',
         Format => 'int16u',
         RawConv => '$val ? $val : undef',
     },
-    0x1c => { #PH
+    0x1c => [
+        { #PH
+            Name => 'ContrastDetectAFInFocus',
+            Condition => '$$self{AFInfo2Version} eq "0100"',
+            PrintConv => { 0 => 'No', 1 => 'Yes' },
+        },{ #PH (D500, see forum11190)
+            Name => 'AFPointsSelected',
+            Condition => '$$self{AFInfo2Version} eq "0101" and $$self{PhaseDetectAF} == 7',
+            Format => 'undef[20]',
+            ValueConv => 'join(" ", unpack("H2"x20, $val))',
+            ValueConvInv => '$val=~tr/ //d; pack("H*",$val)',
+            PrintConv => sub { PrintAFPoints(shift, \%afPoints153); },
+            PrintConvInv => sub { PrintAFPointsInv(shift, \%afPoints153); },
+        },
+    ],
+    # 0x1d - always zero (with or without live view)
+    0x2a => { #PH (Z7)
+        Name => 'AFImageWidth',
+        Condition => '$$self{AFInfo2Version} =~ /^03/',
+        Format => 'int16u',
+        RawConv => '$val ? $val : undef',
+    },
+    0x2c => { #PH (Z7)
+        Name => 'AFImageHeight',
+        Condition => '$$self{AFInfo2Version} =~ /^03/',
+        Format => 'int16u',
+        RawConv => '$val ? $val : undef',
+    },
+    0x2e => { #PH (Z7)
+        Name => 'AFAreaXPosition',
+        Condition => q{
+            $$self{ContrastDetectAF} == 2 and $$self{AFInfo2Version} =~ /^03/ or
+            $$self{ContrastDetectAF} == 1 and $$self{AFInfo2Version} =~ /^0301/
+        },
+        Format => 'int16u',
+    },
+    0x2f => { #28 (Z7)   Still photography range 1-17 for the 493 point Z7 (arranged in a 29x17 grid. Center at x=16, y=10).
+        Name => 'AFFocusPointXPosition',
+        Condition => q{
+            $$self{ContrastDetectAF} == 2 and $$self{AFInfo2Version} =~ /^03/ or
+            $$self{ContrastDetectAF} == 1 and $$self{AFInfo2Version} =~ /^0301/
+        },
+        PrintConv => sub { my ($val) = @_; PrintAFPointsLeftRight($val, 29 ); },
+    },
+    0x30 => [
+        { #PH (Z7)
+            Name => 'AFAreaYPosition',
+            Condition => q{
+                $$self{ContrastDetectAF} == 2 and $$self{AFInfo2Version} =~ /^03/ or
+                $$self{ContrastDetectAF} == 1 and $$self{AFInfo2Version} =~ /^0301/
+            },
+            Format => 'int16u',
+        },{ #PH (D500, see forum11190)
+            Name => 'AFPointsInFocus',
+            Condition => '$$self{AFInfo2Version} eq "0101" and $$self{PhaseDetectAF} == 7',
+            Notes => 'AF points in focus at the time time image was captured',
+            Format => 'undef[20]',
+            ValueConv => 'join(" ", unpack("H2"x20, $val))',
+            ValueConvInv => '$val=~tr/ //d; pack("H*",$val)',
+            PrintConv => sub { PrintAFPoints(shift, \%afPoints153); },
+            PrintConvInv => sub { PrintAFPointsInv(shift, \%afPoints153); },
+        },
+    ],
+    0x31 => { #28 (Z7)
+        Name => 'AFFocusPointYPosition',
+        Condition => q{
+            $$self{ContrastDetectAF} == 2 and $$self{AFInfo2Version} =~ /^03/ or
+            $$self{ContrastDetectAF} == 1 and $$self{AFInfo2Version} =~ /^0301/
+        },
+        PrintConv => sub { my ($val) = @_; PrintAFPointsUpDown($val, 17 ); },
+    },
+    0x32 => { #PH (Z7)
+        Name => 'AFAreaWidth',
+        Condition => '$$self{AFInfo2Version} =~ /^03/',
+        Format => 'int16u',
+        RawConv => '$val ? $val : undef',
+    },
+    0x34 => { #PH (Z7)
+        Name => 'AFAreaHeight',
+        Condition => '$$self{AFInfo2Version} =~ /^03/',
+        Format => 'int16u',
+        RawConv => '$val ? $val : undef',
+    },
+    0x38 => { #28
+        Name => 'PrimaryAFPoint',
+        Condition => '$$self{PhaseDetectAF} == 9 and $$self{AFInfo2Version} =~ /^03/',
+        Notes => q{
+            Nikon models with 105-point AF -- 7 rows (A-G) and 15 columns (1-15): D6
+        },
+        PrintConvColumns => 5,
+        PrintConv => {
+            0 => '(none)',
+            %afPoints105,
+            1 => 'D8 (Center)',
+        },
+    },
+    0x44 => [
+        {
+            Name => 'PrimaryAFPoint',
+            Condition => '$$self{PhaseDetectAF} == 7 and $$self{AFInfo2Version} eq "0101"',
+            PrintConvColumns => 5,
+            PrintConv => {
+                0 => '(none)',
+                %afPoints153,
+                1 => 'E9 (Center)',
+            },
+        },
+        { #PH
+            Name => 'PrimaryAFPoint',
+            Notes => 'D3500',
+            Condition => '$$self{PhaseDetectAF} == 2 and $$self{AFInfo2Version} eq "0101"',
+            PrintConvColumns => 2,
+            PrintConv => {
+                0 => '(none)',
+                1 => 'Center',
+                2 => 'Top',
+                3 => 'Bottom',
+                4 => 'Mid-left',
+                5 => 'Upper-left',
+                6 => 'Lower-left',
+                7 => 'Far Left',
+                8 => 'Mid-right',
+                9 => 'Upper-right',
+                10 => 'Lower-right',
+                11 => 'Far Right',
+            },
+        },
+        {
+            Name => 'PrimaryAFPoint',
+            Condition => '$$self{AFInfo2Version} eq "0101"',
+            Notes => 'future models?...',
+            Priority => 0,
+            PrintConv => {
+                0 => '(none)',
+                1 => 'Center',
+            },
+        },
+    ],
+    0x46 => {
+        Name => 'AFImageWidth',
+        Condition => '$$self{ContrastDetectAF} == 1 and $$self{AFInfo2Version} eq "0101"',
+        Format => 'int16u',
+        RawConv => '$val ? $val : undef',
+        Notes => 'this and the following tags are valid only for contrast-detect AF',
+    },
+    0x48 => {
+        Name => 'AFImageHeight',
+        Condition => '$$self{ContrastDetectAF} == 1 and $$self{AFInfo2Version} eq "0101"',
+        Format => 'int16u',
+        RawConv => '$val ? $val : undef',
+    },
+    0x4a => {
+        Name => 'AFAreaXPosition',
+        Condition => '$$self{ContrastDetectAF} == 1 and $$self{AFInfo2Version} eq "0101"',
+        Notes => 'center of AF area in AFImage coordinates',
+        Format => 'int16u',
+        RawConv => '$val ? $val : undef',
+    },
+    0x4c => {
+        Name => 'AFAreaYPosition',
+        Condition => '$$self{ContrastDetectAF} == 1 and $$self{AFInfo2Version} eq "0101"',
+        Format => 'int16u',
+        RawConv => '$val ? $val : undef',
+    },
+    0x4e => {
+        Name => 'AFAreaWidth',
+        Condition => '$$self{ContrastDetectAF} == 1 and $$self{AFInfo2Version} eq "0101"',
+        Format => 'int16u',
+        Notes => 'size of AF area in AFImage coordinates',
+        RawConv => '$val ? $val : undef',
+    },
+    0x50 => {
+        Name => 'AFAreaHeight',
+        Condition => '$$self{ContrastDetectAF} == 1 and $$self{AFInfo2Version} eq "0101"',
+        Format => 'int16u',
+        RawConv => '$val ? $val : undef',
+    },
+    0x52 => {
         Name => 'ContrastDetectAFInFocus',
+        Condition => '$$self{ContrastDetectAF} == 1 and $$self{AFInfo2Version} eq "0101"',
         PrintConv => { 0 => 'No', 1 => 'Yes' },
     },
-    # 0x1d - always zero (with or without live view)
 );
 
@@ -2377,4 +3967,5 @@
             1 => 'On (1)',
             2 => 'On (2)',
+            3 => 'On (Zoom)', #28
         },
     },
@@ -2386,4 +3977,5 @@
     },
     2 => {
+        # when AFFineTune = 3 (indicating a zoom lens), this Tag stores the tuning adjustment for the wide end of the zoom range (ref 28)
         Name => 'AFFineTuneAdj',
         Priority => 0, # so other value takes priority if it exists
@@ -2393,4 +3985,35 @@
         PrintConvInv => '$val',
     },
+    3 => {
+        Name => 'AFFineTuneAdjTele',
+        # should probably insert a Condition that restricts this to AFFineTune = 3 (ref 28)
+        Notes => 'only valid for zoom lenses (ie, AFTune=3)',
+        Format => 'int8s',
+        PrintConv => '$val > 0 ? "+$val" : $val',
+        PrintConvInv => '$val',
+    },
+);
+
+# Nikon NEF processing information (ref forum6281)
+%Image::ExifTool::Nikon::RetouchInfo = (
+    %binaryDataAttrs,
+    FORMAT => 'int8s',
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    DATAMEMBER => [ 0 ],
+    0 => {
+        Name => 'RetouchInfoVersion',
+        Format => 'undef[4]',
+        Writable => 0,
+        RawConv => '$$self{RetouchInfoVersion} = $val',
+    },
+    # 4 - RetouchExposureComp (+$val/6 or -$val/6?)
+    5 => {
+        Name => 'RetouchNEFProcessing',
+        Condition => '$$self{RetouchInfoVersion} ge "0200"',
+        PrintConv => {
+            -1 => 'Off',
+            1 => 'On',
+        },
+    },
 );
 
@@ -2399,4 +4022,5 @@
     %binaryDataAttrs,
     GROUPS => { 0 => 'MakerNotes', 2 => 'Image' },
+    FORMAT => 'int16u',
     0 => {
         Name => 'FileInfoVersion',
@@ -2404,16 +4028,33 @@
         Writable => 0,
     },
-    6 => {
+    2 => 'MemoryCardNumber',
+    3 => {
         Name => 'DirectoryNumber',
-        Format => 'int16u',
         PrintConv => 'sprintf("%.3d", $val)',
         PrintConvInv => '$val',
     },
-    8 => {
+    4 => {
         Name => 'FileNumber',
-        Format => 'int16u',
         PrintConv => 'sprintf("%.4d", $val)',
         PrintConvInv => '$val',
     },
+);
+
+# ref PH
+%Image::ExifTool::Nikon::BarometerInfo = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Location' },
+    0 => {
+        Name => 'BarometerInfoVersion',
+        Format => 'undef[4]',
+        Writable => 0,
+    },
+    6 => {
+        Name => 'Altitude',
+        Format => 'int32s',
+        PrintConv => '"$val m"', # (always stored as metres)
+        PrintConvInv => '$val=~s/\s*m$//; $val',
+    },
+    # 10: int16u - values: 0 (display in metres?), 18 (display in feet?)
 );
 
@@ -2422,4 +4063,6 @@
     PROCESS_PROC => \&ProcessNikonCaptureOffsets,
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    # (note that these are duplicates of offsets in the normal TIFF structure,
+    #  and that these offsets are not updated when ExifTool rewrites the file)
     1 => 'IFD0_Offset',
     2 => 'PreviewIFD_Offset',
@@ -2439,21 +4082,110 @@
 );
 
-# ref 4
+# ref IB
 %Image::ExifTool::Nikon::ColorBalanceA = (
     %binaryDataAttrs,
     FORMAT => 'int16u',
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
-    624 => {
-        Name => 'RedBalance',
-        ValueConv => '$val / 256',
-        ValueConvInv => '$val * 256',
+    624 => { #4
+        Name => 'WB_RBLevels',
+        Notes => 'as shot', #IB
+        Format => 'int16u[2]',
         Protected => 1,
     },
-    625 => {
-        Name => 'BlueBalance',
-        ValueConv => '$val / 256',
-        ValueConvInv => '$val * 256',
+    626 => {
+        Name => 'WB_RBLevelsAuto',
+        Format => 'int16u[2]',
         Protected => 1,
     },
+    628 => {
+        Name => 'WB_RBLevelsDaylight',
+        Notes => 'red/blue levels for 0,+3,+2,+1,-1,-2,-3',
+        Format => 'int16u[14]',
+        Protected => 1,
+    },
+    642 => {
+        Name => 'WB_RBLevelsIncandescent',
+        Format => 'int16u[14]',
+        Protected => 1,
+    },
+    656 => {
+        Name => 'WB_RBLevelsFluorescent',
+        Format => 'int16u[6]',
+        Notes => 'red/blue levels for fluorescent W,N,D',
+        Protected => 1,
+    },
+    662 => {
+        Name => 'WB_RBLevelsCloudy',
+        Format => 'int16u[14]',
+        Protected => 1,
+    },
+    676 => {
+        Name => 'WB_RBLevelsFlash',
+        Format => 'int16u[14]',
+        Protected => 1,
+    },
+    690 => {
+        Name => 'WB_RBLevelsShade',
+        Condition => '$$self{Model} ne "E8700"',
+        Notes => 'not valid for E8700',
+        Format => 'int16u[14]',
+        Protected => 1,
+    },
+);
+
+my %nrwLevels = (
+    Format => 'int32u[4]',
+    Protected => 1,
+    ValueConv => 'my @a=split " ",$val;$a[0]*=2;$a[3]*=2;"@a"',
+    ValueConvInv => 'my @a=split " ",$val;$a[0]/=2;$a[3]/=2;"@a"',
+);
+
+# (ref IB)
+%Image::ExifTool::Nikon::ColorBalanceB = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'Color balance tags used by the P6000.',
+    0x0004 => {
+        Name => 'ColorBalanceVersion',
+        Format => 'undef[4]',
+    },
+    0x13e8 => { Name => 'WB_RGGBLevels',            %nrwLevels },
+    0x13f8 => { Name => 'WB_RGGBLevelsDaylight',    %nrwLevels },
+    0x1408 => { Name => 'WB_RGGBLevelsCloudy',      %nrwLevels },
+    0x1428 => { Name => 'WB_RGGBLevelsTungsten',    %nrwLevels },
+    0x1438 => { Name => 'WB_RGGBLevelsFluorescentW',%nrwLevels },
+    0x1448 => { Name => 'WB_RGGBLevelsFlash',       %nrwLevels },
+    0x1468 => { Name => 'WB_RGGBLevelsCustom',      %nrwLevels, Notes => 'all zero if preset WB not used' },
+    0x1478 => { Name => 'WB_RGGBLevelsAuto',        %nrwLevels },
+);
+
+# (ref IB)
+%Image::ExifTool::Nikon::ColorBalanceC = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    DATAMEMBER => [ 4 ],
+    NOTES => 'Color balance tags used by the P1000, P7000, P7100 and B700.',
+    0x0004 => {
+        Name => 'ColorBalanceVersion',
+        Format => 'undef[4]',
+        RawConv => '$$self{ColorBalanceVersion} = $val',
+    },
+    0x0020 => { Name => 'BlackLevel', Format => 'int16u' },
+    0x0038 => { Name => 'WB_RGGBLevels',            %nrwLevels },
+    0x004c => { Name => 'WB_RGGBLevelsDaylight',    %nrwLevels },
+    0x0060 => { Name => 'WB_RGGBLevelsCloudy',      %nrwLevels },
+    0x0074 => {
+        Name => 'WB_RGGBLevelsShade',
+        Condition => '$$self{ColorBalanceVersion} ge "0104"',
+        Notes => 'valid only for some models',
+        %nrwLevels,
+    },
+    0x0088 => { Name => 'WB_RGGBLevelsTungsten',    %nrwLevels },
+    0x009c => { Name => 'WB_RGGBLevelsFluorescentW',%nrwLevels },
+    0x00b0 => { Name => 'WB_RGGBLevelsFluorescentN',%nrwLevels },
+    0x00c4 => { Name => 'WB_RGGBLevelsFluorescentD',%nrwLevels },
+    0x00d8 => { Name => 'WB_RGGBLevelsHTMercury',   %nrwLevels },
+    0x0100 => { Name => 'WB_RGGBLevelsCustom',      %nrwLevels, Notes => 'all zero if preset WB not used' },
+    0x0114 => { Name => 'WB_RGGBLevelsAuto',        %nrwLevels },
 );
 
@@ -2504,4 +4236,13 @@
         Format => 'int16u[4]',
         Protected => 1,
+    },
+);
+
+%Image::ExifTool::Nikon::ColorBalanceUnknown = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    0 => {
+        Name => 'ColorBalanceVersion',
+        Format => 'undef[4]',
     },
 );
@@ -2557,4 +4298,5 @@
         DataTag => 'PreviewImage',
         Writable => 'int32u',
+        WriteGroup => 'MakerNotes',
         Protected => 2,
     },
@@ -2565,4 +4307,5 @@
         DataTag => 'PreviewImage',
         Writable => 'int32u',
+        WriteGroup => 'MakerNotes',
         Protected => 2,
     },
@@ -2629,5 +4372,5 @@
         %nikonApertureConversions,
     },
-    0x0c => 'MCUVersion', #8
+    0x0c => 'MCUVersion', #8 (MCU = Micro Controller Unit)
 );
 
@@ -2669,5 +4412,5 @@
     0x09 => { #8/9
         # With older AF lenses this does not work... (ref 13)
-        # ie) AF Nikkor 50mm f/1.4 => 48 (0x30)
+        # eg) AF Nikkor 50mm f/1.4 => 48 (0x30)
         # AF Zoom-Nikkor 35-105mm f/3.5-4.5 => @35mm => 15 (0x0f), @105mm => 141 (0x8d)
         Notes => 'this focus distance is approximate, and not very accurate for some lenses',
@@ -2710,5 +4453,5 @@
         %nikonApertureConversions,
     },
-    0x11 => 'MCUVersion', #8
+    0x11 => 'MCUVersion', #8 (MCU = Micro Controller Unit)
     0x12 => { #8
         Name => 'EffectiveMaxAperture',
@@ -2755,5 +4498,5 @@
     0x0a => { #8/9
         # With older AF lenses this does not work... (ref 13)
-        # ie) AF Nikkor 50mm f/1.4 => 48 (0x30)
+        # eg) AF Nikkor 50mm f/1.4 => 48 (0x30)
         # AF Zoom-Nikkor 35-105mm f/3.5-4.5 => @35mm => 15 (0x0f), @105mm => 141 (0x8d)
         Notes => 'this focus distance is approximate, and not very accurate for some lenses',
@@ -2796,8 +4539,222 @@
         %nikonApertureConversions,
     },
-    0x12 => 'MCUVersion', #8
+    0x12 => 'MCUVersion', #8 (MCU = Micro Controller Unit)
     0x13 => { #8
         Name => 'EffectiveMaxAperture',
         %nikonApertureConversions,
+    },
+);
+
+# Nikon lens data version 0400 (note: needs decrypting) (ref PH)
+%Image::ExifTool::Nikon::LensData0400 = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'Tags extracted from the encrypted lens data of the Nikon 1J1/1V1/1J2.',
+    0x00 => {
+        Name => 'LensDataVersion',
+        Format => 'string[4]',
+        Writable => 0,
+    },
+    0x18a => { #PH
+        Name => 'LensModel',
+        Format => 'string[64]',
+    },
+);
+
+# Nikon lens data version 0402 (note: needs decrypting) (ref PH)
+%Image::ExifTool::Nikon::LensData0402 = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'Tags extracted from the encrypted lens data of the Nikon 1J3/1S1/1V2.',
+    0x00 => {
+        Name => 'LensDataVersion',
+        Format => 'string[4]',
+        Writable => 0,
+    },
+    0x18b => { #PH
+        Name => 'LensModel',
+        Format => 'string[64]',
+    },
+);
+
+# Nikon lens data version 0403 (note: needs decrypting) (ref PH)
+%Image::ExifTool::Nikon::LensData0403 = (
+    %binaryDataAttrs,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'Tags extracted from the encrypted lens data of the Nikon 1J4/1J5.',
+    0x00 => {
+        Name => 'LensDataVersion',
+        Format => 'string[4]',
+        Writable => 0,
+    },
+    0x2ac => { #PH
+        Name => 'LensModel',
+        Format => 'string[64]',
+    },
+);
+
+# Nikon Z lens data (note: needs decrypting) (ref PH, based on LensData0204)
+%Image::ExifTool::Nikon::LensData0800 = (
+    %binaryDataAttrs,
+    NOTES => 'Tags found in the encrypted LensData from cameras such as the Z6 and Z7.',
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    DATAMEMBER => [ 0x03, 0x2f ],
+    0x00 => {
+        Name => 'LensDataVersion',
+        Format => 'string[4]',
+        Writable => 0,
+    },
+    0x03 => { # look forward to see if new old data exists...
+        Name => 'OldLensData',
+        Format => 'undef[17]',
+        RawConv => '$$self{OldLensData} = 1 unless $val =~ /^.\0+$/s; undef',
+        Hidden => 1,
+    },
+    0x04 => {
+        Name => 'ExitPupilPosition',
+        Condition => '$$self{OldLensData}',
+        ValueConv => '$val ? 2048 / $val : $val',
+        ValueConvInv => '$val ? 2048 / $val : $val',
+        PrintConv => 'sprintf("%.1f mm",$val)',
+        PrintConvInv => '$val=~s/\s*mm$//; $val',
+    },
+    0x05 => {
+        Name => 'AFAperture',
+        Condition => '$$self{OldLensData}',
+        %nikonApertureConversions,
+    },
+    # --> another extra byte at position 0x08 in this version of LensData (PH)
+    0x09 => {
+        Name => 'FocusPosition',
+        Condition => '$$self{OldLensData}',
+        PrintConv => 'sprintf("0x%02x", $val)',
+        PrintConvInv => '$val',
+    },
+    0x0b => {
+        Notes => 'this focus distance is approximate, and not very accurate for some lenses',
+        Name => 'FocusDistance',
+        Condition => '$$self{OldLensData}',
+        ValueConv => '0.01 * 10**($val/40)', # in m
+        ValueConvInv => '$val>0 ? 40*log($val*100)/log(10) : 0',
+        PrintConv => '$val ? sprintf("%.2f m",$val) : "inf"',
+        PrintConvInv => '$val eq "inf" ? 0 : $val =~ s/\s*m$//, $val',
+    },
+    0x0c => {
+        Name => 'FocalLength',
+        Condition => '$$self{OldLensData}',
+        Priority => 0,
+        %nikonFocalConversions,
+    },
+    0x0d => {
+        Name => 'LensIDNumber',
+        Condition => '$$self{OldLensData}',
+        Notes => 'see LensID values below',
+    },
+    0x0e => {
+        Name => 'LensFStops',
+        Condition => '$$self{OldLensData}',
+        ValueConv => '$val / 12',
+        ValueConvInv => '$val * 12',
+        PrintConv => 'sprintf("%.2f", $val)',
+        PrintConvInv => '$val',
+    },
+    0x0f => {
+        Name => 'MinFocalLength',
+        Condition => '$$self{OldLensData}',
+        %nikonFocalConversions,
+    },
+    0x10 => {
+        Name => 'MaxFocalLength',
+        Condition => '$$self{OldLensData}',
+        %nikonFocalConversions,
+    },
+    0x11 => {
+        Name => 'MaxApertureAtMinFocal',
+        Condition => '$$self{OldLensData}',
+        %nikonApertureConversions,
+    },
+    0x12 => {
+        Name => 'MaxApertureAtMaxFocal',
+        Condition => '$$self{OldLensData}',
+        %nikonApertureConversions,
+    },
+    0x13 => {
+        Name => 'MCUVersion',
+        Condition => '$$self{OldLensData}',
+    },
+    0x14 => {
+        Name => 'EffectiveMaxAperture',
+        Condition => '$$self{OldLensData}',
+        %nikonApertureConversions,
+    },
+#
+# ---- new LensData tags used by Nikkor Z lenses ---- (ref PH)
+#
+    0x2f => { # look forward to see if new lens data exists...
+        Name => 'NewLensData',
+        Format => 'undef[17]',
+        RawConv => '$$self{NewLensData} = 1 unless $val =~ /^.\0+$/s; undef',
+        Hidden => 1,
+    },
+    0x30 => {
+        Name => 'LensID',
+        Condition => '$$self{NewLensData}',
+        Notes => 'tags from here onward used for Nikkor Z lenses only',
+        Format => 'int16u',
+        PrintConv => {
+             1 => 'Nikkor Z 24-70mm f/4 S',
+             2 => 'Nikkor Z 14-30mm f/4 S',
+             4 => 'Nikkor Z 35mm f/1.8 S',
+             8 => 'Nikkor Z 58mm f/0.95 S Noct', #IB
+             9 => 'Nikkor Z 50mm f/1.8 S',
+            11 => 'Nikkor Z DX 16-50mm f/3.5-6.3 VR',
+            12 => 'Nikkor Z DX 50-250mm f/4.5-6.3 VR',
+            13 => 'Nikkor Z 24-70mm f/2.8 S',
+            14 => 'Nikkor Z 85mm f/1.8 S',
+            15 => 'Nikkor Z 24mm f/1.8 S', #IB
+            16 => 'Nikkor Z 70-200mm f/2.8 VR S', #IB
+            17 => 'Nikkor Z 20mm f/1.8 S', #IB
+            18 => 'Nikkor Z 24-200mm f/4-6.3 VR', #IB
+            21 => 'Nikkor Z 50mm f/1.2 S', #IB
+            22 => 'Nikkor Z 24-50mm f/4-6.3', #IB
+            23 => 'Nikkor Z 14-24mm f/2.8 S', #IB
+        },
+    },
+    0x36 => {
+        Name => 'MaxAperture',
+        Condition => '$$self{NewLensData}',
+        Format => 'int16u',
+        Priority => 0,
+        ValueConv => '2**($val/384-1)',
+        ValueConvInv => '384*(log($val)/log(2)+1)',
+        PrintConv => 'sprintf("%.1f",$val)',
+        PrintConvInv => '$val',
+    },
+    0x38 => {
+        Name => 'FNumber',
+        Condition => '$$self{NewLensData}',
+        Format => 'int16u',
+        Priority => 0,
+        ValueConv => '2**($val/384-1)',
+        ValueConvInv => '384*(log($val)/log(2)+1)',
+        PrintConv => 'sprintf("%.1f",$val)',
+        PrintConvInv => '$val',
+    },
+    0x3c => {
+        Name => 'FocalLength',
+        Condition => '$$self{NewLensData}',
+        Format => 'int16u',
+        Priority => 0,
+        PrintConv => '"$val mm"',
+        PrintConvInv => '$val=~s/\s*mm$//;$val',
+    },
+    0x4f => {
+        Name => 'FocusDistance',
+        Condition => '$$self{NewLensData}',
+        # (perhaps int16u Format? -- although upper byte would always be zero)
+        ValueConv => '0.01 * 10**($val/40)', # in m
+        ValueConvInv => '$val>0 ? 40*log($val*100)/log(10) : 0',
+        PrintConv => '$val ? sprintf("%.2f m",$val) : "inf"',
+        PrintConvInv => '$val eq "inf" ? 0 : $val =~ s/\s*m$//, $val',
     },
 );
@@ -2892,4 +4849,5 @@
         },
     },
+    # 0xac - int16u[600] TiffMeteringImage1: 30x20 image (ShotInfoVersion 0800, ref JR)
     0x157 => { #JD
         Name => 'ShutterCount',
@@ -2922,4 +4880,12 @@
     },
     # note: DecryptLen currently set to 0x251
+
+    # 0x55c - int16u[2400] TiffMeteringImage2: 60x40 image (ShotInfoVersion 0800, ref JR)
+    # 0x181c - int16u[1200] TiffMeteringImage?: 60x20 image for some NEF's (ShotInfoVersion 0800, ref JR)
+    # 0x217c - int16u[2400] TiffMeteringImage3: 60x40 image (ShotInfoVersion 0800, ref JR)
+    # 0x3d9c - int16u[2400] TiffMeteringImage4: 60x40 image (ShotInfoVersion 0800, ref JR)
+    # 0x59c0 - TiffMeteringImageWidth (ShotInfoVersion 0800, ref JR)
+    # 0x59c2 - TiffMeteringImageHeight (ShotInfoVersion 0800, ref JR)
+    # 0x59c4 - int16u[1800] TiffMeteringImage5: 30x20 RGB image (ShotInfoVersion 0800, ref JR)
 );
 
@@ -2948,8 +4914,5 @@
         Name => 'VibrationReduction',
         Mask => 0x08,
-        PrintConv => {
-            0x00 => 'Off',
-            0x08 => 'On',
-        },
+        PrintConv => { 0 => 'Off', 1 => 'On' },
     },
     729 => { #JD
